     function idxCtr = ctr2node(X, ctrs, idx)
%% function idxCtr = ctr2node(X, ctrs, idx)
%% get the closest node (its index) to each center.
%% get closets center to every node       
   nC = size(ctrs,1)
   idxCtr = zeros(nC, 1);
   %%
   for i=1:nC
       %%-------------------- ith center
       ci = ctrs(i,:);
       %%-------------------- ith set 
       ix = find(idx==i);
       xi = X(ix,:);
       ni = size(xi,1);
       %%-------------------- distances
       dst = sum((xi- ones(ni,1)*ci) .^2,2);
       %%-------------------- closest item
       [~,k] = min(dst);
       idxCtr(i) = ix(k);
   end
