 function [B, XN, prnt, wo] = coarsestep(D, X, wx) 
% IN
%  X   = data matrix - each columns contains a point (e.g, xyz
%        coordinates or some other features);
%  D   = weight matrix..  
%  wx  = weights of vertices 
% OUT: 
%  B    = Output sparse  matrix of weights
%  XN   = coarse nodes (coarsened `features')
%  prnt = parents array : node i in old graph has parent prnt(i) 
%        in coarse graph 
% 
N = size(D,1);     % Numbers of nodes of the given (fine) graph.
prnt = zeros(N,1); % 
%%-------------------- unroll sparse matrix into arrays.
[I, J, W] = find(D);
nz = length(J);

% W = W + 0.001*randn(size(W));

[dummy, indx] = sort(W,'descend');
%[dummy, indx] = sort(W,'descend');
%%indx(1:200)
%%indx = randperm(nz) ;
new = 0;
%%indx = randperm(nz);

for k = 1:nz 
    next = indx(k);
    i = I(next);
    if (prnt(i) >0 ), continue, end;
    j = J(next);
%%-------------------- exclude i->i links
    if (i == j), continue, end;
    if (prnt(j) >0), continue, end;
%%-------------------- create new node 
    new = new+1;
%%disp(new)
%%-------------------- parents of this new node 
    prnt(i) = new;
    prnt(j) = new;
    t  = wx(i) + wx(j);
    XN(:,new) = (X(:,i) + X(:,j)) * 0.5;
    %%XN(:,new) = (X(:,i)*wx(i) + X(:,j)*wx(j)) /t; 
    wo(new) = t*.5;
end
%%     disp( new )
%%-------------------- mop up - left-over singletons
   for ii=1:N
       if (prnt(ii) == 0) 
           new = new+1;
           prnt(ii) = new;
           XN(:,new) = X(:,ii);
           wo(new) = wx(ii); 
         end
    end
%%-------------------- now build the weight graph;
    B = sparse(new,new);
    for k=1:nz
        i = prnt(I(k)); j=prnt(J(k));
        if (i ~= j)
            B(i,j) = 1.0; 
        end
    end

