function [Y] = ONPP(X,K,d) 
%%  function [V] = ONPP(X,K,d) 
% Inputs:
% X = data as m x N matrix (m = dimensionality, N = #points)
% label = vector of labels 
% K = number of neighbors 
% d = embedding dimensionality
% V =  projected data 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m,n] = size(X)
pause 
%%-------------------- do PCA projection -- 
X = double(X);
adj_list = kNNgraph(X,K);
%%
%
if (m>n) 
   [U0, S0, V0] = svd(X);
   X = U0(1:n,1:n)*S0(1:n,1:n)*V0';
end
v = sum(X,2)/m;
X = X - v*ones(1,n);

%%if(K>D) 
if(K>0) 
  fprintf(1,'   [note: K>m; regularization will be used]\n'); 
  tol=1e-3; % regularlizer in case constrained fits are ill conditioned
else
  tol=0;
end
%%-------------------- get graph 
%compute the local graph matrix and W coefficients
W = zeros(K,n);
for ii=1:n
   z = X(:,adj_list{ii})-repmat(X(:,ii),1,K); % shift ith pt to origin
   C = z'*z;                                        % local covariance
   C = C + eye(K,K)*tol*trace(C);                   % regularlization (K>m)
%   W(:,ii) = C\ones(K,1);                          % solve Cw=1
   W(:,ii) = pinv(C)*ones(K,1);                     % solve Cw=1
   W(:,ii) = W(:,ii)/sum(W(:,ii));                  % enforce sum(w)=1
end;

% exk change: construct myW
myW = sparse(n,n);
%%%myW = sparse(myW);
for ii = 1:n
    %ind = neighborhood(:,ii);
    ind = adj_list{ii};
    myW(ind,ii) = W(:,ii);
end

% STEP 3: COMPUTE EMBEDDING FROM EIGENVECTS OF COST MATRIX M=(I-W)'(I-W)
%fprintf(1,'-->Computing embedding.\n');

%use X(I-W)' instead of (I-W)'...
W = myW';
Xtilda = X*(eye(n)-W');
M = Xtilda*Xtilda';

% CALCULATION OF EMBEDDING
options.disp = 0; options.isreal = 1; options.issym = 1; 
[V,eigenvals] = eig(M); 
%%%%%,d+1,'SM',options);
[eigval,index] = sort(diag(eigenvals));
V = V(:,index);
V = V(:,2:d+1); 
Y = V'*X;

